package com.ecep.contract.util;

import org.hibernate.proxy.HibernateProxy;

public class HibernateProxyUtils {
    private static boolean useProxy = true;

    public static void useProxy(boolean b) {
        useProxy = b;
    }

    public static boolean isNotEffectiveClassEquals(Object the, Object that) {
        if (!useProxy) {
            return false;
        }
        Class<?> oEffectiveClass = the instanceof HibernateProxy
                ? ((HibernateProxy) the).getHibernateLazyInitializer().getPersistentClass()
                : the.getClass();
        Class<?> thisEffectiveClass = that instanceof HibernateProxy
                ? ((HibernateProxy) that).getHibernateLazyInitializer().getPersistentClass()
                : that.getClass();
        if (thisEffectiveClass != oEffectiveClass)
            return false;
        return true;
    }

    public static int hashCode(Object that) {
        if (!useProxy) {
            return that.hashCode();
        }
        return that instanceof HibernateProxy
                ? ((HibernateProxy) that).getHibernateLazyInitializer().getPersistentClass().hashCode()
                : that.getClass().hashCode();
    }

}
